#!/bin/exu
with trace
--------------------------------------------------------------------------------
--
-- Name:         EuDoc - Euphoria documentation program
-- Author:       D. Newhall
-- Version:      0.1
-- License:      Mozilla
-- Created:         Feb-7-2005
-- Updated:      Feb-14-2005
-- Updated:      Jul-13-2005
-- Updated:      Jul-29-2005
-- Intro:
--
--   To get the full documentation for EuDoc please type "ex EuDoc.e EuDocLib.e"
--   at the command prompt (substituting "exu" or "exw" for "ex" if necessary).
--
--------------------------------------------------------------------------------


-- Possible future features:
--
--   Finish debugging routines
--   "Input:", "Output:", "Requires:" tags (suggestions and comments welcome)
--   Multiple files into one HTML file
--   Better text prompts
--   Fix minor formatting bug related to spaces after ':' getting removed when
--     testing for tag
--   Syntax highlighting for Example text
--   Bug fixes  :P



-- Include library file

include EuDocLib.e



-- Note: all routines are defined in EuDocLib.e



-- Get command line arguments and open files
get_command_line_options()


object line

integer fn,
	index,
	index2


for i=1 to length(Filenums) do

    -- Set parse type to get library info first after every file and 
    --  reset Parsing to FALSE
    Parse_type = LIBRARY
    Parsing = FALSE

    -- Get next file number
    fn = Filenums[i]

    -- Read file line by line
    line = gets(fn)
    while sequence(line) do

	-- Get index of start of comment text
	index = comment(line)

	if index > 0 then -- If line is a comment
	    index2 = match(":", line[index..length(line)])
	    if index2 > 0 then -- If there's a ':' in the line
		-- Next line is confusing since index2 is an offset of index
		read_line(
		  line[index..(index + index2 - 1)],
		  line[(index + index2 + 1)..length(line)] )
	    else -- No tag
		if Parsing = TRUE then
		    read_line("", line)
		end if
	    end if
	    
	-- Change Parsing to FALSE if line isn't a comment
	else
	    Parsing = FALSE
	end if

	line = gets(fn)

    end while
    
    -- Generate HTML documentation from accumulated data
    generate_html()
    
    -- Debugging routine (leave commented unless you need it)
    --print_data("edlog.txt")
    
    -- Close file after done
    close(fn)
    
    -- Empty info holding variables for next file
    Routines = {}

end for
